import { DeclareConstructor } from "dojo/_base/declare";
import { FocusManager } from "./focus";

declare module "./_WidgetBase" {

    interface _WidgetBase {
        /**
         * This widget or a widget it contains has focus, or is "active" because
         * it was recently clicked.
         */
        focused: boolean;

        /**
         * Called when the widget becomes "active" because
         * it or a widget inside of it either has focus, or has recently
         * been clicked.
         */
        onFocus(): void;

        /**
         * Called when the widget stops being "active" because
         * focus moved to something outside of it, or the user
         * clicked somewhere outside of it, or the widget was
         * hidden.
         */
        onBlur(): void;
    }
}

interface _FocusMixin {
    _focusManager: FocusManager;
}

declare module "dojo/_base/kernel" {
    interface Dijit {
        _FocusMixin: _FocusMixinConstructor;
    }
}

type _FocusMixinConstructor = DeclareConstructor<_FocusMixin>;
declare const _FocusMixin: _FocusMixinConstructor;
export = _FocusMixin;
